package geniusweb.protocol;

import geniusweb.actions.PartyId;
import geniusweb.party.Party;
import geniusweb.references.PartyRef;

/**
 * thrown if a {@link Party} violates the protocols (that includes
 * disconnecting).
 */
public class ProtocolException extends Exception {
	private String party; // the failing party

	/**
	 * 
	 * @param message the error message
	 * @param party   offending party, either the {@link PartyId} or a
	 *                {@link PartyRef}
	 */
	public ProtocolException(String message, String party) {
		super(party + ":" + message);
		this.party = party;
	}

	/**
	 * 
	 * @param message the error message
	 * @param party   offending party, either the {@link PartyId} or a
	 *                {@link PartyRef}
	 * @param e       the cause of the error
	 */
	public ProtocolException(String message, String party, Throwable e) {
		super(party + ":" + message, e);
		this.party = party;
	}

	/**
	 * 
	 * @return offending party, either the {@link PartyId} or a {@link PartyRef}
	 */
	public String getParty() {
		return party;
	}

}
